#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
# CLOCK
create_clock -period 20.000ns [get_ports OSC_50_B3B]
create_clock -period 20.000ns [get_ports OSC_50_B4A]
create_clock -period 20.000ns [get_ports OSC_50_B4D]
create_clock -period 20.000ns [get_ports OSC_50_B7A]
create_clock -period 20.000ns [get_ports OSC_50_B7D]
create_clock -period 20.000ns [get_ports OSC_50_B8A]
create_clock -period 20.000ns [get_ports OSC_50_B8D]
create_clock -period "125.0 MHz" -name FMCA_NET0_RX_CLK [get_ports FMCA_NET0_RX_CLK]
create_clock -period "125.0 MHz" -name FMCA_NET1_RX_CLK [get_ports FMCA_NET1_RX_CLK]
create_clock -period "125.0 MHz" -name FMCA_NET2_RX_CLK [get_ports FMCA_NET2_RX_CLK]
create_clock -period "125.0 MHz" -name FMCA_NET3_RX_CLK [get_ports FMCA_NET3_RX_CLK]
#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks


#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty


###############################################

#
#NET0
#

# TSE MAC 
set_min_delay  2 -from * -to [get_ports {FMCA_NET0_MDC FMCA_NET0_MDIO FMCA_NET0_RESETN}]
set_max_delay 10 -from * -to [get_ports {FMCA_NET0_MDC FMCA_NET0_MDIO FMCA_NET0_RESETN}]

set_min_delay  0 -from [get_ports {FMCA_NET0_MDIO}] -to *
set_max_delay  6 -from [get_ports {FMCA_NET0_MDIO}] -to *

#**************************************************************
# Input Delay Constraints (Center aligned, Same Edge Analysis)
#**************************************************************
# max delay = tco (0.5) + skew (0.075)
# min delay = tcomin (-0.5) - skew (0.075)

# Constraint the path to the rising edge of the phy clock
set_input_delay -clock FMCA_NET0_RX_CLK -max  0.575 [get_ports {FMCA_NET0_RX_DV FMCA_NET0_RX_D*}]
set_input_delay -clock FMCA_NET0_RX_CLK -min -0.575 [get_ports {FMCA_NET0_RX_DV FMCA_NET0_RX_D*}]

# Constraint the path to the falling edge of the phy clock
set_input_delay -clock FMCA_NET0_RX_CLK -max  0.575 [get_ports {FMCA_NET0_RX_DV FMCA_NET0_RX_D*}] -clock_fall -add_delay
set_input_delay -clock FMCA_NET0_RX_CLK -min -0.575 [get_ports {FMCA_NET0_RX_DV FMCA_NET0_RX_D*}] -clock_fall -add_delay 


# On a same edge capture DDR interface the paths from RISE to FALL and
# from FALL to RISE on not valid for setup analysis
set_false_path -setup \
    -rise_from [get_clocks {FMCA_NET0_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET0_RX_CLK}]

set_false_path -setup \
    -fall_from [get_clocks {FMCA_NET0_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET0_RX_CLK}]

# On a same edge capture DDR interface the paths from RISE to RISE and
# FALL to FALL are not avlid for hold analysis
set_false_path -hold \
    -rise_from [get_clocks {FMCA_NET0_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET0_RX_CLK}]

set_false_path -hold \
    -fall_from [get_clocks {FMCA_NET0_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET0_RX_CLK}]   

	 
	 

###############################################

#
#NET1
#

# TSE MAC 
set_min_delay  2 -from * -to [get_ports {FMCA_NET1_MDC FMCA_NET1_MDIO FMCA_NET1_RESETN}]
set_max_delay 10 -from * -to [get_ports {FMCA_NET1_MDC FMCA_NET1_MDIO FMCA_NET1_RESETN}]

set_min_delay  0 -from [get_ports {FMCA_NET1_MDIO}] -to *
set_max_delay  6 -from [get_ports {FMCA_NET1_MDIO}] -to *

#**************************************************************
# Input Delay Constraints (Center aligned, Same Edge Analysis)
#**************************************************************
# max delay = tco (0.5) + skew (0.075)
# min delay = tcomin (-0.5) - skew (0.075)

# Constraint the path to the rising edge of the phy clock
set_input_delay -clock FMCA_NET1_RX_CLK -max  0.575 [get_ports {FMCA_NET1_RX_DV FMCA_NET1_RX_D*}]
set_input_delay -clock FMCA_NET1_RX_CLK -min -0.575 [get_ports {FMCA_NET1_RX_DV FMCA_NET1_RX_D*}]

# Constraint the path to the falling edge of the phy clock
set_input_delay -clock FMCA_NET1_RX_CLK -max  0.575 [get_ports {FMCA_NET1_RX_DV FMCA_NET1_RX_D*}] -clock_fall -add_delay
set_input_delay -clock FMCA_NET1_RX_CLK -min -0.575 [get_ports {FMCA_NET1_RX_DV FMCA_NET1_RX_D*}] -clock_fall -add_delay 


# On a same edge capture DDR interface the paths from RISE to FALL and
# from FALL to RISE on not valid for setup analysis
set_false_path -setup \
    -rise_from [get_clocks {FMCA_NET1_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET1_RX_CLK}]

set_false_path -setup \
    -fall_from [get_clocks {FMCA_NET1_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET1_RX_CLK}]

# On a same edge capture DDR interface the paths from RISE to RISE and
# FALL to FALL are not avlid for hold analysis
set_false_path -hold \
    -rise_from [get_clocks {FMCA_NET1_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET1_RX_CLK}]

set_false_path -hold \
    -fall_from [get_clocks {FMCA_NET1_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET1_RX_CLK}]   

	 
	 

###############################################

#
#NET2
#

# TSE MAC 
set_min_delay  2 -from * -to [get_ports {FMCA_NET2_MDC FMCA_NET2_MDIO FMCA_NET2_RESETN}]
set_max_delay 10 -from * -to [get_ports {FMCA_NET2_MDC FMCA_NET2_MDIO FMCA_NET2_RESETN}]

set_min_delay  0 -from [get_ports {FMCA_NET2_MDIO}] -to *
set_max_delay  6 -from [get_ports {FMCA_NET2_MDIO}] -to *

#**************************************************************
# Input Delay Constraints (Center aligned, Same Edge Analysis)
#**************************************************************
# max delay = tco (0.5) + skew (0.075)
# min delay = tcomin (-0.5) - skew (0.075)

# Constraint the path to the rising edge of the phy clock
set_input_delay -clock FMCA_NET2_RX_CLK -max  0.575 [get_ports {FMCA_NET2_RX_DV FMCA_NET2_RX_D*}]
set_input_delay -clock FMCA_NET2_RX_CLK -min -0.575 [get_ports {FMCA_NET2_RX_DV FMCA_NET2_RX_D*}]

# Constraint the path to the falling edge of the phy clock
set_input_delay -clock FMCA_NET2_RX_CLK -max  0.575 [get_ports {FMCA_NET2_RX_DV FMCA_NET2_RX_D*}] -clock_fall -add_delay
set_input_delay -clock FMCA_NET2_RX_CLK -min -0.575 [get_ports {FMCA_NET2_RX_DV FMCA_NET2_RX_D*}] -clock_fall -add_delay 


# On a same edge capture DDR interface the paths from RISE to FALL and
# from FALL to RISE on not valid for setup analysis
set_false_path -setup \
    -rise_from [get_clocks {FMCA_NET2_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET2_RX_CLK}]

set_false_path -setup \
    -fall_from [get_clocks {FMCA_NET2_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET2_RX_CLK}]

# On a same edge capture DDR interface the paths from RISE to RISE and
# FALL to FALL are not avlid for hold analysis
set_false_path -hold \
    -rise_from [get_clocks {FMCA_NET2_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET2_RX_CLK}]

set_false_path -hold \
    -fall_from [get_clocks {FMCA_NET2_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET2_RX_CLK}]   

	 
	 
	 

###############################################

#
#NET3
#

# TSE MAC 
set_min_delay  2 -from * -to [get_ports {FMCA_NET3_MDC FMCA_NET3_MDIO FMCA_NET3_RESETN}]
set_max_delay 10 -from * -to [get_ports {FMCA_NET3_MDC FMCA_NET3_MDIO FMCA_NET3_RESETN}]

set_min_delay  0 -from [get_ports {FMCA_NET3_MDIO}] -to *
set_max_delay  6 -from [get_ports {FMCA_NET3_MDIO}] -to *

#**************************************************************
# Input Delay Constraints (Center aligned, Same Edge Analysis)
#**************************************************************
# max delay = tco (0.5) + skew (0.075)
# min delay = tcomin (-0.5) - skew (0.075)

# Constraint the path to the rising edge of the phy clock
set_input_delay -clock FMCA_NET3_RX_CLK -max  0.575 [get_ports {FMCA_NET3_RX_DV FMCA_NET3_RX_D*}]
set_input_delay -clock FMCA_NET3_RX_CLK -min -0.575 [get_ports {FMCA_NET3_RX_DV FMCA_NET3_RX_D*}]

# Constraint the path to the falling edge of the phy clock
set_input_delay -clock FMCA_NET3_RX_CLK -max  0.575 [get_ports {FMCA_NET3_RX_DV FMCA_NET3_RX_D*}] -clock_fall -add_delay
set_input_delay -clock FMCA_NET3_RX_CLK -min -0.575 [get_ports {FMCA_NET3_RX_DV FMCA_NET3_RX_D*}] -clock_fall -add_delay 


# On a same edge capture DDR interface the paths from RISE to FALL and
# from FALL to RISE on not valid for setup analysis
set_false_path -setup \
    -rise_from [get_clocks {FMCA_NET3_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET3_RX_CLK}]

set_false_path -setup \
    -fall_from [get_clocks {FMCA_NET3_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET3_RX_CLK}]

# On a same edge capture DDR interface the paths from RISE to RISE and
# FALL to FALL are not avlid for hold analysis
set_false_path -hold \
    -rise_from [get_clocks {FMCA_NET3_RX_CLK}] \
    -rise_to [get_clocks {FMCA_NET3_RX_CLK}]

set_false_path -hold \
    -fall_from [get_clocks {FMCA_NET3_RX_CLK}] \
    -fall_to [get_clocks {FMCA_NET3_RX_CLK}]   

	 
	 


