// ============================================================================
// Copyright (c) 2016 by Terasic Technologies Inc.
// ============================================================================
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// ============================================================================
//           
//  Terasic Technologies Inc
//  9F., No.176, Sec.2, Gongdao 5th Rd, East Dist, Hsinchu City, 30070. Taiwan
//  
//  
//                     web: http://www.terasic.com/  
//                     email: support@terasic.com
//
// ============================================================================
//Date:  Wed Mar 16 09:30:16 2016
// ============================================================================

//`define ENABLE_DDR3
//`define ENABLE_PCIE
//`define ENABLE_SATA
`define ENABLE_FMCA_NET
//`define ENABLE_FMCB_NET
//`define ENABLE_FMCC_NET
//`define ENABLE_FMCD_NET
`define DDR3_RANK_NUM   1  //2
module TR5_golden_top(

      ///////// CLOCK /////////
      input              OSC_50_B3B,
      input              OSC_50_B4A,
      input              OSC_50_B4D,
      input              OSC_50_B7A,
      input              OSC_50_B7D,
      input              OSC_50_B8A,
      input              OSC_50_B8D,

      ///////// KEY /////////
      input              CPU_RESET_n,
      input    [ 3: 0]   BUTTON, //KEY is Low-Active

      ///////// SW /////////
      input    [ 3: 0]   SW,

      ///////// LED /////////
      output   [ 3: 0]   LED, //LED is Low-Active

      ///////// FAN /////////
      input              FAN_ALERT_n,

      ///////// SSRAM /////////
      output             SSRAM_CLK,
      output             SSRAM_CKE_n,
      output             SSRAM_CE_n,
      output             SSRAM_WE_n,
      output             SSRAM_OE_n,
      output             SSRAM_ADV,
      output             SSRAM_BWA_n,
      output             SSRAM_BWB_n,

      ///////// FLASH /////////
      output             FLASH_CLK,
      output             FLASH_CE_n,
      output             FLASH_WE_n,
      output             FLASH_OE_n,
      output             FLASH_ADV_n,
      output             FLASH_RESET_n,
      input              FLASH_RDY_BSY_n,

      ///////// FSM /////////
      output   [26: 0]   FSM_A,
      inout    [15: 0]   FSM_D,

      ///////// SD Card /////////
      output             SD_CLK,
      inout    [ 3: 0]   SD_DATA,
      inout              SD_CMD,

`ifdef ENABLE_DDR3
      ///////// DDR3 /////////
      input              DDR3_REFCLK_p,
      output   [15: 0]   DDR3_A,
      output   [ 2: 0]   DDR3_BA,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CK,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CK_n,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CKE,
      inout    [ 7: 0]   DDR3_DQS,
      inout    [ 7: 0]   DDR3_DQS_n,
      inout    [63: 0]   DDR3_DQ,
      output   [ 7: 0]   DDR3_DM,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_CS_n,
      output             DDR3_WE_n,
      output             DDR3_CAS_n,
      output             DDR3_RAS_n,
      output             DDR3_RESET_n,
      output   [ (`DDR3_RANK_NUM-1):0]   DDR3_ODT,
      input              DDR3_EVENT_n,
      output             DDR3_SCL,
      inout              DDR3_SDA,
`endif /*ENABLE_DDR3*/

      ///////// RZQ /////////
      input              RZQ_DDR3,
      input              RZQ_FMC,

      ///////// Uart to USB /////////
      output             UART_TX,
      input              UART_RX,

      ///////// TPS40422 /////////
      output             TPS40422_CLK,
      inout              TPS40422_DATA,
      input              TPS40422_ALERT,

      ///////// External PLL /////////
      output             LMK04906_CLK,
      output             LMK04906_DATAIN,
      input              LMK04906_DATAOUT,
      output             LMK04906_LE,

      ///////// I2C /////////
      output             CLOCK_SCL,
      inout              CLOCK_SDA,

      ///////// Shared I2C /////////
      inout              FPGA_I2C_SCL,
      inout              FPGA_I2C_SDA,

      ///////// Temperature /////////
      input              TEMP_INT_n,
      input              TEMP_OVERT_n,

      ///////// POWER Monitor /////////
      input              POWER_MONITOR_ALERT,

      ///////// GPIO /////////
      inout    [35: 0]   GPIO,


`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      input              PCIE_ONBOARD_REFCLK_p,
      input              PCIE_REFCLK_p,
      output   [ 3: 0]   PCIE_TX_p,
      input    [ 3: 0]   PCIE_RX_p,
      input              PCIE_PERST_n,
      output             PCIE_WAKE_n,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_SATA
      ///////// SATA /////////
      input              SATA_HOST_REFCLK_p,
      output             SATA_HOST_TX_p,
      input              SATA_HOST_RX_p,
      input              SATA_DEVICE_REFCLK_p,
      output             SATA_DEVICE_TX_p,
      input              SATA_DEVICE_RX_p, 
`endif /*ENABLE_SATA*/


      ///////// SMA /////////
      input              SMA_CLKIN_p,
      output             SMA_CLKOUT_p,

`ifdef ENABLE_FMCA_NET
      ///////// FMCA-NET /////////
		output				 FMCA_NET0_GTX_CLK,
		input 				 FMCA_NET0_INTN,
		input 				 FMCA_NET0_LINK1000,
		output				 FMCA_NET0_MDC,
		inout 				 FMCA_NET0_MDIO,
		output				 FMCA_NET0_RESETN,
		input 				 FMCA_NET0_RX_CLK,
		input 				 FMCA_NET0_RX_COL,
		input 				 FMCA_NET0_RX_CRS,
		input 	[3:0]		 FMCA_NET0_RX_D,
		input 				 FMCA_NET0_RX_DV,
		input 				 FMCA_NET0_RX_ER,
		input 				 FMCA_NET0_S_CLKP,
		input 				 FMCA_NET0_S_RX_P,
		output				 FMCA_NET0_S_TX_P,
		input 				 FMCA_NET0_TX_CLK,
		output	[7:0]		 FMCA_NET0_TX_D,
		output				 FMCA_NET0_TX_EN,
		output				 FMCA_NET0_TX_ER,
		
		output				 FMCA_NET1_GTX_CLK,
		input 				 FMCA_NET1_INTN,
		input 				 FMCA_NET1_LINK1000,
		output				 FMCA_NET1_MDC,
		inout 				 FMCA_NET1_MDIO,
		output				 FMCA_NET1_RESETN,
		input 				 FMCA_NET1_RX_CLK,
		input 				 FMCA_NET1_RX_COL,
		input 				 FMCA_NET1_RX_CRS,
		input 	[3:0]		 FMCA_NET1_RX_D,
		input 				 FMCA_NET1_RX_DV,
		input 				 FMCA_NET1_RX_ER,
		input 				 FMCA_NET1_S_CLKP,
		input 				 FMCA_NET1_S_RX_P,
		output				 FMCA_NET1_S_TX_P,
		input 				 FMCA_NET1_TX_CLK,
		output	[7:0]		 FMCA_NET1_TX_D,
		output				 FMCA_NET1_TX_EN,
		output				 FMCA_NET1_TX_ER,
		
		output				 FMCA_NET2_GTX_CLK,
		input 				 FMCA_NET2_INTN,
		input 				 FMCA_NET2_LINK1000,
		output				 FMCA_NET2_MDC,
		inout 				 FMCA_NET2_MDIO,
		output				 FMCA_NET2_RESETN,
		input 				 FMCA_NET2_RX_CLK,
		input 				 FMCA_NET2_RX_COL,
		input 				 FMCA_NET2_RX_CRS,
		input 	[3:0]		 FMCA_NET2_RX_D,
		input 				 FMCA_NET2_RX_DV,
		input 				 FMCA_NET2_RX_ER,
		input 				 FMCA_NET2_S_CLKP,
		input 				 FMCA_NET2_S_RX_P,
		output				 FMCA_NET2_S_TX_P,
		input 				 FMCA_NET2_TX_CLK,
		output	[7:0]		 FMCA_NET2_TX_D,
		output				 FMCA_NET2_TX_EN,
		output				 FMCA_NET2_TX_ER,
		
		output				 FMCA_NET3_GTX_CLK,
		input 				 FMCA_NET3_INTN,
		input 				 FMCA_NET3_LINK1000,
		output				 FMCA_NET3_MDC,
		inout 				 FMCA_NET3_MDIO,
		output				 FMCA_NET3_RESETN,
		input 				 FMCA_NET3_RX_CLK,
		input 				 FMCA_NET3_RX_COL,
		input 				 FMCA_NET3_RX_CRS,
		input 	[3:0]		 FMCA_NET3_RX_D,
		input 				 FMCA_NET3_RX_DV,
		input 				 FMCA_NET3_RX_ER,
		input 				 FMCA_NET3_S_CLKP,
		input 				 FMCA_NET3_S_RX_P,
		output				 FMCA_NET3_S_TX_P,
		input 				 FMCA_NET3_TX_CLK,
		output	[7:0]		 FMCA_NET3_TX_D,
		output				 FMCA_NET3_TX_EN,
		output				 FMCA_NET3_TX_ER
`endif /*ENABLE_FMCA_NET*/


`ifdef ENABLE_FMCB_NET
     ///////// FMCB-NET /////////
		output				 FMCB_NET0_GTX_CLK,
		input 				 FMCB_NET0_INTN,
		output				 FMCB_NET0_MDC,
		inout 				 FMCB_NET0_MDIO,
		output				 FMCB_NET0_RESETN,
		input 				 FMCB_NET0_RX_CLK,
		input 	[3:0]		 FMCB_NET0_RX_D,
		input 				 FMCB_NET0_RX_DV,
		output	[3:0]		 FMCB_NET0_TX_D,
		output				 FMCB_NET0_TX_EN,
		
		output				 FMCB_NET1_GTX_CLK,
		input 				 FMCB_NET1_INTN,
		output				 FMCB_NET1_MDC,
		inout 				 FMCB_NET1_MDIO,
		output				 FMCB_NET1_RESETN,
		input 				 FMCB_NET1_RX_CLK,
		input 	[3:0]		 FMCB_NET1_RX_D,
		input 				 FMCB_NET1_RX_DV,
		output	[3:0]		 FMCB_NET1_TX_D,
		output				 FMCB_NET1_TX_EN,

		output				 FMCB_NET2_GTX_CLK,
		input 				 FMCB_NET2_INTN,
		output				 FMCB_NET2_MDC,
		inout 				 FMCB_NET2_MDIO,
		output				 FMCB_NET2_RESETN,
		input 				 FMCB_NET2_RX_CLK,
		input 	[3:0]		 FMCB_NET2_RX_D,
		input 				 FMCB_NET2_RX_DV,
		output	[3:0]		 FMCB_NET2_TX_D,
		output				 FMCB_NET2_TX_EN,

		output				 FMCB_NET3_GTX_CLK,
		input 				 FMCB_NET3_INTN,
		output				 FMCB_NET3_MDC,
		inout 				 FMCB_NET3_MDIO,
		output				 FMCB_NET3_RESETN,
		input 				 FMCB_NET3_RX_CLK,
		input 	[3:0]		 FMCB_NET3_RX_D,
		input 				 FMCB_NET3_RX_DV,
		output	[3:0]		 FMCB_NET3_TX_D,
		output				 FMCB_NET3_TX_EN,
`endif /*ENABLE_FMCB_NET*/	


`ifdef ENABLE_FMCC_NET	
     ///////// FMCC-NET /////////
		output				 FMCC_NET0_GTX_CLK,
		input 				 FMCC_NET0_INTN,
		output				 FMCC_NET0_MDC,
		inout 				 FMCC_NET0_MDIO,
		output				 FMCC_NET0_RESETN,
		input 				 FMCC_NET0_RX_CLK,
		input 	[3:0]		 FMCC_NET0_RX_D,
		input 				 FMCC_NET0_RX_DV,
		output	[3:0]		 FMCC_NET0_TX_D,
		output				 FMCC_NET0_TX_EN,
		
		output				 FMCC_NET1_GTX_CLK,
		input 				 FMCC_NET1_INTN,
		output				 FMCC_NET1_MDC,
		inout 				 FMCC_NET1_MDIO,
		output				 FMCC_NET1_RESETN,
		input 				 FMCC_NET1_RX_CLK,
		input 	[3:0]		 FMCC_NET1_RX_D,
		input 				 FMCC_NET1_RX_DV,
		output	[3:0]		 FMCC_NET1_TX_D,
		output				 FMCC_NET1_TX_EN,

		output				 FMCC_NET2_GTX_CLK,
		input 				 FMCC_NET2_INTN,
		output				 FMCC_NET2_MDC,
		inout 				 FMCC_NET2_MDIO,
		output				 FMCC_NET2_RESETN,
		input 				 FMCC_NET2_RX_CLK,
		input 	[3:0]		 FMCC_NET2_RX_D,
		input 				 FMCC_NET2_RX_DV,
		output	[3:0]		 FMCC_NET2_TX_D,
		output				 FMCC_NET2_TX_EN,

		output				 FMCC_NET3_GTX_CLK,
		input 				 FMCC_NET3_INTN,
		output				 FMCC_NET3_MDC,
		inout 				 FMCC_NET3_MDIO,
		output				 FMCC_NET3_RESETN,
		input 				 FMCC_NET3_RX_CLK,
		input 	[3:0]		 FMCC_NET3_RX_D,
		input 				 FMCC_NET3_RX_DV,
		output	[3:0]		 FMCC_NET3_TX_D,
		output				 FMCC_NET3_TX_EN,		
`endif /*ENABLE_FMCC_NET*/

`ifdef ENABLE_FMCD_NET
      ///////// FMCD-NET /////////
		output				 FMCD_NET0_GTX_CLK,
		input 				 FMCD_NET0_INTN,
		input 				 FMCD_NET0_LINK1000,
		output				 FMCD_NET0_MDC,
		inout 				 FMCD_NET0_MDIO,
		output				 FMCD_NET0_RESETN,
		input 				 FMCD_NET0_RX_CLK,
		input 				 FMCD_NET0_RX_COL,
		input 				 FMCD_NET0_RX_CRS,
		input 	[3:0]		 FMCD_NET0_RX_D,
		input 				 FMCD_NET0_RX_DV,
		input 				 FMCD_NET0_RX_ER,
		input 				 FMCD_NET0_S_CLKP,
		input 				 FMCD_NET0_S_RX_P,
		output				 FMCD_NET0_S_TX_P,
		input 				 FMCD_NET0_TX_CLK,
		output	[3:0]		 FMCD_NET0_TX_D,
		output				 FMCD_NET0_TX_EN,
		output				 FMCD_NET0_TX_ER,
		
		output				 FMCD_NET1_GTX_CLK,
		input 				 FMCD_NET1_INTN,
		input 				 FMCD_NET1_LINK1000,
		output				 FMCD_NET1_MDC,
		inout 				 FMCD_NET1_MDIO,
		output				 FMCD_NET1_RESETN,
		input 				 FMCD_NET1_RX_CLK,
		input 				 FMCD_NET1_RX_COL,
		input 				 FMCD_NET1_RX_CRS,
		input 	[3:0]		 FMCD_NET1_RX_D,
		input 				 FMCD_NET1_RX_DV,
		input 				 FMCD_NET1_RX_ER,
		input 				 FMCD_NET1_S_CLKP,
		input 				 FMCD_NET1_S_RX_P,
		output				 FMCD_NET1_S_TX_P,
		input 				 FMCD_NET1_TX_CLK,
		output	[3:0]		 FMCD_NET1_TX_D,
		output				 FMCD_NET1_TX_EN,
		output				 FMCD_NET1_TX_ER,
		
		output				 FMCD_NET2_GTX_CLK,
		input 				 FMCD_NET2_INTN,
		input 				 FMCD_NET2_LINK1000,
		output				 FMCD_NET2_MDC,
		inout 				 FMCD_NET2_MDIO,
		output				 FMCD_NET2_RESETN,
		input 				 FMCD_NET2_RX_CLK,
		input 				 FMCD_NET2_RX_COL,
		input 				 FMCD_NET2_RX_CRS,
		input 	[3:0]		 FMCD_NET2_RX_D,
		input 				 FMCD_NET2_RX_DV,
		input 				 FMCD_NET2_RX_ER,
		input 				 FMCD_NET2_S_CLKP,
		input 				 FMCD_NET2_S_RX_P,
		output				 FMCD_NET2_S_TX_P,
		input 				 FMCD_NET2_TX_CLK,
		output	[3:0]		 FMCD_NET2_TX_D,
		output				 FMCD_NET2_TX_EN,
		output				 FMCD_NET2_TX_ER,
		
		output				 FMCD_NET3_GTX_CLK,
		input 				 FMCD_NET3_INTN,
		input 				 FMCD_NET3_LINK1000,
		output				 FMCD_NET3_MDC,
		inout 				 FMCD_NET3_MDIO,
		output				 FMCD_NET3_RESETN,
		input 				 FMCD_NET3_RX_CLK,
		input 				 FMCD_NET3_RX_COL,
		input 				 FMCD_NET3_RX_CRS,
		input 	[3:0]		 FMCD_NET3_RX_D,
		input 				 FMCD_NET3_RX_DV,
		input 				 FMCD_NET3_RX_ER,
		input 				 FMCD_NET3_S_CLKP,
		input 				 FMCD_NET3_S_RX_P,
		output				 FMCD_NET3_S_TX_P,
		input 				 FMCD_NET3_TX_CLK,
		output	[3:0]		 FMCD_NET3_TX_D,
		output				 FMCD_NET3_TX_EN,
		output				 FMCD_NET3_TX_ER
`endif /*ENABLE_FMCD_NET*/		

);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire  global_reset_n;
//ddr3 statu
wire ddr3_local_init_done;
wire ddr3_local_cal_success;
wire ddr3_local_cal_fail;
// ethernet 
wire	enet_tx_clk_mac;
wire  enet_tx_clk_phy;
// ethernet 0
wire	enet0_gtx_clk;
wire  enet0_mdio_oen;
wire  enet0_mdio_out;
// ethernet 1
wire	enet1_gtx_clk;
wire  enet1_mdio_oen;
wire  enet1_mdio_out;
// ethernet 2
wire	enet2_gtx_clk;
wire  enet2_mdio_oen;
wire  enet2_mdio_out;
// ethernet 3
wire	enet3_gtx_clk;
wire  enet3_mdio_oen;
wire  enet3_mdio_out;
//=======================================================
//  Structural coding
//=======================================================
// ethernet clock
assign FMCA_NET0_GTX_CLK = enet0_gtx_clk;
assign FMCA_NET1_GTX_CLK = enet1_gtx_clk;
assign FMCA_NET2_GTX_CLK = enet2_gtx_clk;
assign FMCA_NET3_GTX_CLK = enet3_gtx_clk;
assign FMCA_NET0_TX_D[7:4] = 4'b0000;
assign FMCA_NET1_TX_D[7:4] = 4'b0000;
assign FMCA_NET2_TX_D[7:4] = 4'b0000;
assign FMCA_NET3_TX_D[7:4] = 4'b0000;

// MDIO Tristate 
assign FMCA_NET0_MDIO = (enet0_mdio_oen) ? 1'bz : enet0_mdio_out;		// modified as per GBI
assign FMCA_NET1_MDIO = (enet1_mdio_oen) ? 1'bz : enet1_mdio_out;		// modified as per GBI 
assign FMCA_NET2_MDIO = (enet2_mdio_oen) ? 1'bz : enet2_mdio_out;		// modified as per GBI
assign FMCA_NET3_MDIO = (enet3_mdio_oen) ? 1'bz : enet3_mdio_out;		// modified as per GBI

// Ethernet TX PLL
enet_tx_clk_pll enet_tx_clk_pll (
		  .refclk   (OSC_50_B8D),   		 // refclk.clk
		  .rst      (!BUTTON[0]),      	 // reset.reset
		  .outclk_0 (enet_tx_clk_mac),    // outclk0.clk
);

gen_reset_n  system_gen_reset_n (
        .tx_clk(OSC_50_B8D),
        .reset_n_in(1'b1),
        .reset_n_out(global_reset_n)
);

assign             FLASH_CLK=1'b0;
assign             FLASH_ADV_n=1'b0;
assign             FLASH_RESET_n=global_reset_n;
assign             FMCA_NET0_RESETN=global_reset_n;


wire flash_dummy_addr;	
    fpga_bup u0 (
        .button_pio_out_export                           (BUTTON),                           //                      button_pio_out.export
        .cfi_flash_atb_bridge_0_out_tcm_address_out      (FSM_A),      //          cfi_flash_atb_bridge_0_out.tcm_address_out
        .cfi_flash_atb_bridge_0_out_tcm_read_n_out       (FLASH_OE_n),       //                                    .tcm_read_n_out
        .cfi_flash_atb_bridge_0_out_tcm_write_n_out      (FLASH_WE_n),      //                                    .tcm_write_n_out
        .cfi_flash_atb_bridge_0_out_tcm_data_out         (FSM_D ),         //                                    .tcm_data_out
        .cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out (FLASH_CE_n ), //                                    .tcm_chipselect_n_out
        .led_pio_external_connection_export              (LED),               //         led_pio_external_connection.export
        .merged_resets_in_reset_reset_n                  (global_reset_n),                  //              merged_resets_in_reset.reset_n
        .sys_clk_clk                                     (OSC_50_B8D ),                                     //                             sys_clk.clk
//        .mdc_from_the_tse_mac                            (FMCA_NET0_MDC),                       					// tse_mac0_mac_mdio_connection.mdc
//        .mdio_in_to_the_tse_mac                          (FMCA_NET0_MDIO),                   						//                             .mdio_in
//        .mdio_out_from_the_tse_mac                       (enet0_mdio_out),                  						//                             .mdio_out
//        .mdio_oen_from_the_tse_mac                       (enet0_mdio_oen),                  						//                             .mdio_oen
        .mdc_from_the_tse_mac                            (FMCA_NET0_MDC),                       					// tse_mac0_mac_mdio_connection.mdc
        .mdio_in_to_the_tse_mac                          (FMCA_NET0_MDIO),                   						//                             .mdio_in
        .mdio_out_from_the_tse_mac                       (enet0_mdio_out),                  						//                             .mdio_out
        .mdio_oen_from_the_tse_mac                       (enet0_mdio_oen),                  						//                             .mdio_oen

//        .tse_mac_conduit_connection_txp                  (FMCA_NET0_S_TX_P ),                  //                           .txp
//        .tse_mac_conduit_connection_rxp                  (FMCA_NET0_S_RX_P ),                  //                           .rxp
        .tse_mac_pcs_ref_clk_clock_connection_clk        (enet_tx_clk_mac ),              //                           .ref_clk
		  .tse_mac_serial_connection_txp                  (FMCA_NET0_S_TX_P ),                  //                           .txp
        .tse_mac_serial_connection_rxp                  (FMCA_NET0_S_RX_P ),                  //                           .rxp
     

	);


	 
       
endmodule
