	component fpga_bup is
		port (
			button_pio_out_export                           : in    std_logic_vector(2 downto 0)  := (others => 'X'); -- export
			cfi_flash_atb_bridge_0_out_tcm_address_out      : out   std_logic_vector(26 downto 0);                    -- tcm_address_out
			cfi_flash_atb_bridge_0_out_tcm_read_n_out       : out   std_logic_vector(0 downto 0);                     -- tcm_read_n_out
			cfi_flash_atb_bridge_0_out_tcm_write_n_out      : out   std_logic_vector(0 downto 0);                     -- tcm_write_n_out
			cfi_flash_atb_bridge_0_out_tcm_data_out         : inout std_logic_vector(15 downto 0) := (others => 'X'); -- tcm_data_out
			cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out : out   std_logic_vector(0 downto 0);                     -- tcm_chipselect_n_out
			lcd_external_RS                                 : out   std_logic;                                        -- RS
			lcd_external_RW                                 : out   std_logic;                                        -- RW
			lcd_external_data                               : inout std_logic_vector(7 downto 0)  := (others => 'X'); -- data
			lcd_external_E                                  : out   std_logic;                                        -- E
			led_pio_external_connection_export              : out   std_logic_vector(7 downto 0);                     -- export
			merged_resets_in_reset_reset_n                  : in    std_logic                     := 'X';             -- reset_n
			sys_clk_clk                                     : in    std_logic                     := 'X';             -- clk
			mdc_from_the_tse_mac                            : out   std_logic;                                        -- mdc
			mdio_in_to_the_tse_mac                          : in    std_logic                     := 'X';             -- mdio_in
			mdio_out_from_the_tse_mac                       : out   std_logic;                                        -- mdio_out
			mdio_oen_from_the_tse_mac                       : out   std_logic;                                        -- mdio_oen
			tse_mac_mac_misc_connection_magic_wakeup        : out   std_logic;                                        -- magic_wakeup
			tse_mac_mac_misc_connection_magic_sleep_n       : in    std_logic                     := 'X';             -- magic_sleep_n
			tse_mac_mac_misc_connection_ff_tx_crc_fwd       : in    std_logic                     := 'X';             -- ff_tx_crc_fwd
			tse_mac_mac_misc_connection_ff_tx_septy         : out   std_logic;                                        -- ff_tx_septy
			tse_mac_mac_misc_connection_tx_ff_uflow         : out   std_logic;                                        -- tx_ff_uflow
			tse_mac_mac_misc_connection_ff_tx_a_full        : out   std_logic;                                        -- ff_tx_a_full
			tse_mac_mac_misc_connection_ff_tx_a_empty       : out   std_logic;                                        -- ff_tx_a_empty
			tse_mac_mac_misc_connection_rx_err_stat         : out   std_logic_vector(17 downto 0);                    -- rx_err_stat
			tse_mac_mac_misc_connection_rx_frm_type         : out   std_logic_vector(3 downto 0);                     -- rx_frm_type
			tse_mac_mac_misc_connection_ff_rx_dsav          : out   std_logic;                                        -- ff_rx_dsav
			tse_mac_mac_misc_connection_ff_rx_a_full        : out   std_logic;                                        -- ff_rx_a_full
			tse_mac_mac_misc_connection_ff_rx_a_empty       : out   std_logic;                                        -- ff_rx_a_empty
			tse_mac_pcs_ref_clk_clock_connection_clk        : in    std_logic                     := 'X';             -- clk
			tse_mac_serdes_control_connection_export        : out   std_logic;                                        -- export
			tse_mac_serial_connection_txp                   : out   std_logic;                                        -- txp
			tse_mac_serial_connection_rxp                   : in    std_logic                     := 'X';             -- rxp
			tse_mac_status_led_connection_crs               : out   std_logic;                                        -- crs
			tse_mac_status_led_connection_link              : out   std_logic;                                        -- link
			tse_mac_status_led_connection_panel_link        : out   std_logic;                                        -- panel_link
			tse_mac_status_led_connection_col               : out   std_logic;                                        -- col
			tse_mac_status_led_connection_an                : out   std_logic;                                        -- an
			tse_mac_status_led_connection_char_err          : out   std_logic;                                        -- char_err
			tse_mac_status_led_connection_disp_err          : out   std_logic                                         -- disp_err
		);
	end component fpga_bup;

	u0 : component fpga_bup
		port map (
			button_pio_out_export                           => CONNECTED_TO_button_pio_out_export,                           --                       button_pio_out.export
			cfi_flash_atb_bridge_0_out_tcm_address_out      => CONNECTED_TO_cfi_flash_atb_bridge_0_out_tcm_address_out,      --           cfi_flash_atb_bridge_0_out.tcm_address_out
			cfi_flash_atb_bridge_0_out_tcm_read_n_out       => CONNECTED_TO_cfi_flash_atb_bridge_0_out_tcm_read_n_out,       --                                     .tcm_read_n_out
			cfi_flash_atb_bridge_0_out_tcm_write_n_out      => CONNECTED_TO_cfi_flash_atb_bridge_0_out_tcm_write_n_out,      --                                     .tcm_write_n_out
			cfi_flash_atb_bridge_0_out_tcm_data_out         => CONNECTED_TO_cfi_flash_atb_bridge_0_out_tcm_data_out,         --                                     .tcm_data_out
			cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out => CONNECTED_TO_cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out, --                                     .tcm_chipselect_n_out
			lcd_external_RS                                 => CONNECTED_TO_lcd_external_RS,                                 --                         lcd_external.RS
			lcd_external_RW                                 => CONNECTED_TO_lcd_external_RW,                                 --                                     .RW
			lcd_external_data                               => CONNECTED_TO_lcd_external_data,                               --                                     .data
			lcd_external_E                                  => CONNECTED_TO_lcd_external_E,                                  --                                     .E
			led_pio_external_connection_export              => CONNECTED_TO_led_pio_external_connection_export,              --          led_pio_external_connection.export
			merged_resets_in_reset_reset_n                  => CONNECTED_TO_merged_resets_in_reset_reset_n,                  --               merged_resets_in_reset.reset_n
			sys_clk_clk                                     => CONNECTED_TO_sys_clk_clk,                                     --                              sys_clk.clk
			mdc_from_the_tse_mac                            => CONNECTED_TO_mdc_from_the_tse_mac,                            --          tse_mac_mac_mdio_connection.mdc
			mdio_in_to_the_tse_mac                          => CONNECTED_TO_mdio_in_to_the_tse_mac,                          --                                     .mdio_in
			mdio_out_from_the_tse_mac                       => CONNECTED_TO_mdio_out_from_the_tse_mac,                       --                                     .mdio_out
			mdio_oen_from_the_tse_mac                       => CONNECTED_TO_mdio_oen_from_the_tse_mac,                       --                                     .mdio_oen
			tse_mac_mac_misc_connection_magic_wakeup        => CONNECTED_TO_tse_mac_mac_misc_connection_magic_wakeup,        --          tse_mac_mac_misc_connection.magic_wakeup
			tse_mac_mac_misc_connection_magic_sleep_n       => CONNECTED_TO_tse_mac_mac_misc_connection_magic_sleep_n,       --                                     .magic_sleep_n
			tse_mac_mac_misc_connection_ff_tx_crc_fwd       => CONNECTED_TO_tse_mac_mac_misc_connection_ff_tx_crc_fwd,       --                                     .ff_tx_crc_fwd
			tse_mac_mac_misc_connection_ff_tx_septy         => CONNECTED_TO_tse_mac_mac_misc_connection_ff_tx_septy,         --                                     .ff_tx_septy
			tse_mac_mac_misc_connection_tx_ff_uflow         => CONNECTED_TO_tse_mac_mac_misc_connection_tx_ff_uflow,         --                                     .tx_ff_uflow
			tse_mac_mac_misc_connection_ff_tx_a_full        => CONNECTED_TO_tse_mac_mac_misc_connection_ff_tx_a_full,        --                                     .ff_tx_a_full
			tse_mac_mac_misc_connection_ff_tx_a_empty       => CONNECTED_TO_tse_mac_mac_misc_connection_ff_tx_a_empty,       --                                     .ff_tx_a_empty
			tse_mac_mac_misc_connection_rx_err_stat         => CONNECTED_TO_tse_mac_mac_misc_connection_rx_err_stat,         --                                     .rx_err_stat
			tse_mac_mac_misc_connection_rx_frm_type         => CONNECTED_TO_tse_mac_mac_misc_connection_rx_frm_type,         --                                     .rx_frm_type
			tse_mac_mac_misc_connection_ff_rx_dsav          => CONNECTED_TO_tse_mac_mac_misc_connection_ff_rx_dsav,          --                                     .ff_rx_dsav
			tse_mac_mac_misc_connection_ff_rx_a_full        => CONNECTED_TO_tse_mac_mac_misc_connection_ff_rx_a_full,        --                                     .ff_rx_a_full
			tse_mac_mac_misc_connection_ff_rx_a_empty       => CONNECTED_TO_tse_mac_mac_misc_connection_ff_rx_a_empty,       --                                     .ff_rx_a_empty
			tse_mac_pcs_ref_clk_clock_connection_clk        => CONNECTED_TO_tse_mac_pcs_ref_clk_clock_connection_clk,        -- tse_mac_pcs_ref_clk_clock_connection.clk
			tse_mac_serdes_control_connection_export        => CONNECTED_TO_tse_mac_serdes_control_connection_export,        --    tse_mac_serdes_control_connection.export
			tse_mac_serial_connection_txp                   => CONNECTED_TO_tse_mac_serial_connection_txp,                   --            tse_mac_serial_connection.txp
			tse_mac_serial_connection_rxp                   => CONNECTED_TO_tse_mac_serial_connection_rxp,                   --                                     .rxp
			tse_mac_status_led_connection_crs               => CONNECTED_TO_tse_mac_status_led_connection_crs,               --        tse_mac_status_led_connection.crs
			tse_mac_status_led_connection_link              => CONNECTED_TO_tse_mac_status_led_connection_link,              --                                     .link
			tse_mac_status_led_connection_panel_link        => CONNECTED_TO_tse_mac_status_led_connection_panel_link,        --                                     .panel_link
			tse_mac_status_led_connection_col               => CONNECTED_TO_tse_mac_status_led_connection_col,               --                                     .col
			tse_mac_status_led_connection_an                => CONNECTED_TO_tse_mac_status_led_connection_an,                --                                     .an
			tse_mac_status_led_connection_char_err          => CONNECTED_TO_tse_mac_status_led_connection_char_err,          --                                     .char_err
			tse_mac_status_led_connection_disp_err          => CONNECTED_TO_tse_mac_status_led_connection_disp_err           --                                     .disp_err
		);

